#!/usr/bin/env ruby
require "functions"
require "help_array"
require "modules/cgi/cgi"

puts <<EOF
Content-type: text/html

EOF

cgi = CGI.new
message=HELP_TEXT['credits']

if (cgi.has_key?("help")):
	help_section = cgi['help']

	message="No help available"
	if (cgi.has_key?("help")):
		help_section = cgi['help']
		if HELP_TEXT.has_key?(help_section)
			message=HELP_TEXT[help_section]
		end
	end
end

if (cgi.has_key?("command")):
	command = cgi['command']
	
	case command
		when "kick_mac"
			if (cgi.has_key?("mac"))
				mac=cgi['mac']
				if check_mac(mac)
					kick_mac(mac)
					message='<p class="confirm">The MAC was kicked</p>'
				else
					message='<p class="warning">The MAC was invalid</p>'
				end
			end
		when "add_ssid"
			if (cgi.has_key?("ssid"))
				ssid=cgi['ssid']
				if check_ssid(ssid)
					add_ssid(ssid)
					message='<p class="confirm">The SSID was added to the list</p>'
				else
					message='<p class="warning">The SSID was invalid</p>>'
				end
			end
	end
end

if (cgi.has_key?("add_ssid_value")):
	ssid = cgi['add_ssid_value']
	if check_ssid(ssid)
		add_ssid(ssid)
		message='<p class="confirm">The SSID was added to the list</p>'
	else
		message='<p class="warning">The SSID was invalid</p>'
	end
end

if (cgi.has_key?("create")):
	create_interface()
	interface_up()
	message='<p class="confirm">The interface was created</p>'
end

if (cgi.has_key?("karmastatus")):
	if (is_karam_on()):
		karma_off()
		message='<p class="confirm">Karma was turned off</p>'
	else
		karma_on()
		message='<p class="confirm">Karma was turned on</p>'
	end
end

if (cgi.has_key?("bringup")):
	if (is_interface_up()):
		interface_down()
		message='<p class="confirm">The interface was taken down</p>'
	else
		interface_up()
		message='<p class="confirm">The interface was brought up</p>'
	end
end

if (cgi.has_key?("blackwhite")):
	if (is_karma_blacklist()):
		karma_whitelist()
		message='<p class="confirm">Karma was set to Whiltelist mode</p>'
	else
		karma_blacklist()
		message='<p class="confirm">Karma was set to Blacklist mode</p>'
	end
end

if (cgi.has_key?("reset")):
	clear_ssid_list()
	message='<p class="confirm">The SSID list was reset</p>'
end

puts <<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>	
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<title>Jasager - Karma on the Fon</title>
	<meta name="description" content="Karma on the Fon" />
	<meta name="keywords" content="jasager karma fon"/>
	<link rel="stylesheet" type="text/css" href="/css/jasager.css" />
	<script src="/prototype.js" type="text/javascript"></script>
	<script src="/jasager.js" type="text/javascript"></script>
</head>
<body onload="init()"><div id="body-wrap">
	<h1>Jasager</h1>
	<div id="top-panel"><div class="wrap">
	<div id="messages-panel">
		<h2>Help/Messages</h2>
		<div id="messages-replace">
			#{message}
		</div>
		<p class="help"><a onclick="return show_help('credits')" href="status.rb?help=credits">Credits<span></span></a></p>
	</div>
	<div id="status-panel">
		<h2>Status / Main Controls</h2>
		<form method="post" action="/cgi-bin/status.rb">
			<p>
EOF

if (interface_exists()):
	puts <<EOF
	Interface ath0 not found<br />
	<input name="create" type="submit" value="Create and setup interface" />
	</p>
	</form>
	<p class="help"><a onclick="return show_help('status')" href="status.rb?help=status">Help<span> with Status</span></a></p>
	</div><!-- /#status -->
	
	<div class="clear"></div>
	</div></div><!-- /#top-panel -->
	

<div id="bottom-panel"><div class="wrap">
<div id="clients-panel">
	<h2>Connected Clients</h2>
</div><!-- /#clients -->

<div id="log-panel">
	<h2>Log</h2>
	</div>
	
	<div class="clear"></div>
	</div></div><!-- /#bottom-panel -->
  
EOF
else
	puts "Interface is currently: "
	if (is_interface_up()):
		puts "<span id=\"ifline\" style=\"color:green;\">Up</span>"
	else
		puts "<span id=\"ifline\" style=\"color:red;\">Down</span>"
	end
	puts '<input name="bringup" type="submit" value="Change" onclick="return ifup()"  />'
	puts "<br />"
	puts "Karma is currently: "

	if (is_karam_on()):
		puts "<span id=\"statusline\" style=\"color:green;\">On</span>"
	else
		puts "<span id=\"statusline\" style=\"color:red;\">Off</span>"
	end
	puts '<input name="karmastatus" type="submit" value="Change" onclick="return karmaup()" />'
	puts "<br />"

	puts "Black/Whitelist mode: "
	if (is_karma_blacklist()):
		puts '<span id="blackwhiteline" style="color:black;">Blacklist</span>'
	else
		puts '<span id="blackwhiteline" style="background:black;color:white;">Whitelist</span>'
	end
puts <<EOF
		<input name="blackwhite" type="submit" value="Change" onclick="return blackwhit()" />
		<br />
	
		Reset SSID list: <input name="reset" type="submit" value="Reset SSID list" onclick="return resetlist()" /><br />
		<label for="add_ssid_value">Add SSID to list:</label>
		<input id="add_ssid_value" name="add_ssid_value" type="text" value="" /> <input name="add" type="submit" value="Add SSID to list" onclick="return addtolist()" /><br />
	</p>
	</form>
	<p class="help"><a onclick="return show_help('status')" href="status.rb?help=status">Help<span> with Status</span></a></p>
	</div><!-- /#status -->
	
	<div class="clear"></div>
	</div></div><!-- /#top-panel -->
	

<div id="bottom-panel"><div class="wrap">
<div id="clients-panel">
	<h2>Connected Clients</h2>
	<p class="explain">A list of connected clients.</p>
	<script type="text/javascript">
	/* <![CDATA[ */
	document.write ('<input type="button" value="Refresh client list" onclick="refresh_connected_clients()" />');
	/* ]]> */
	</script>	
	<div id="connected-clients">
EOF
	require "connected_clients.inc.rb"
puts <<EOF
	</div>
<p class="help"><a onclick="return show_help('clients')" href="status.rb?help=clients">Help<span> with Connected Clients</span></a></p>
</div><!-- /#clients -->

<div id="log-panel">
	<h2>Log</h2>
	<div class="clear"></div>
	<script type="text/javascript">
	/* <![CDATA[ */
	document.write ('<input type="button" value="Refresh log" onclick="refresh_log()" />');
	/* ]]> */
	</script>	
	<div id="log">
EOF
	require "log.inc.rb"
puts <<EOF
	</div>
	<p class="help"><a onclick="return show_help('log')" href="status.rb?help=log">Help<span> with Log</span></a></p>
	</div>
	
	<div class="clear"></div>
	</div></div><!-- /#bottom-panel -->
	
EOF
end 

puts <<EOF
</div>
</body>
</html>
EOF
